#include "Framework.h"
#pragma hdrstop
#include "FWAppD3D.h"

namespace Spr{;
void FWAppD3D::Load(std::string fn){
	bBusy = true;
	cs.Enter();
	if (!render){
		initialLoadFile = fn;
		return;
	}
	lastLoadFile = fn;

	scene->Clear();
	scene->GetRenderers().Add(render);

	fileIO.Load(lastLoadFile.c_str(), scene);
	ConnectHis();
	cs.Leave();
	bBusy = false;
}
void FWAppD3D::Save(std::string fn){
	bBusy = true;
	cs.Enter();
	fileIO.Save(fn.c_str(), scene);
	cs.Leave();
	bBusy = false;
}

}
