#include <WinBasis/WBWin.h>
#include <HIS/HISpidarG6Jun.h>
#include <Device/DRContecIsaDa.h>
#include <Device/DRContecIsaCounter.h>
#include <Device/DRUsbH8Simple.h>
#include <Device/DRUsb20Simple.h>
#include <Device/DRUsb20Sh4.h>
#include <conio.h>
#include <iostream>
#include <stdio.h>

const float K = 2000;
using namespace Spr;

void main(){
	DVDeviceManager devMan;
	devMan.RPool().Register(new DRUsb20Simple(10));
	devMan.RPool().Register(new DRUsb20Sh4(0));
	devMan.RPool().Register(new DRUsbH8Simple(0));
/*	devMan.RPool().Register(new DRContecIsaDa(0x300));
	devMan.RPool().Register(new DRContecIsaCounter(0x200));
	devMan.RPool().Register(new DRContecIsaCounter(0x210));	*/
	devMan.Init();
	HISpidarG6Jun spidarG6;
	std::cout << devMan;

/*
	std::cout << "hoge" << std::endl;
	//	[^̎tʒu. [^̂ɎtĂꍇ́C
	#define PX	(0.235f/2)		//	x̕ӂ̒/2
	#define PY	(0.225f/2)		//	y̕ӂ̒/2
	#define PZ	(0.235f/2)		//	z̕ӂ̒/2
	//	̃Obvւ̎tʒu
	#define GX	(0.0555f/2)		//	x̕ӂ̒/2
	#define GY	(0.0555f/2)		//	y̕ӂ̒/2
	Vec3f motorPos[8][2] = {	//	[^̎tʒu(S_Ƃ)
		{Vec3f(-PX, PY, PZ), Vec3f(-GX,  0, 0)},
		{Vec3f( PX, PY,-PZ), Vec3f(  0, GY, 0)},
		{Vec3f(-PX,-PY,-PZ), Vec3f(  0,-GY, 0)},
		{Vec3f( PX,-PY, PZ), Vec3f( GX,  0, 0)},
		{Vec3f( PX, PY, PZ), Vec3f( GX,  0, 0)},
		{Vec3f(-PX, PY,-PZ), Vec3f(  0, GY, 0)},
		{Vec3f( PX,-PY,-PZ), Vec3f(  0,-GY, 0)},
		{Vec3f(-PX,-PY, PZ), Vec3f(-GX,  0, 0)}
	};
	spidarG6.Init(devMan, 8, motorPos, 0.3f, 2.924062107079e-5f, 1.0f, 20.0f);
	for(int i=4; i<8; ++i){
		spidarG6.motor[i].lengthPerPulse *= -1;
	}
	spidarG6.Calib();
*/
	spidarG6.Init(devMan);

	while(1){
		if (kbhit()){
			int ch = getch();
			switch(ch){
			case 0x1b:
				return;
			}
		}
		spidarG6.Update(0.001f);
		std::cout << spidarG6.GetPos() << std::endl;
//		for( int i=0; i<8; i++ ) std::cout << spidarG6.motor[i].GetLength() << " ";
//		std::cout << std::endl;
	} 
}
