#ifndef FWPOINTER_H
#define FWPOINTER_H
#include <Physics/PHSolid.h>
#include <HIS/HIHapticDevice.h>

namespace Spr{;
/**	͊oC^tF[XƃV[OťD
	+ V[̂̕Ao^[ƂD
		- o[`JbvOFAo^[_Ci~NXCol_płȂD
		- vLVF_Ci~NXCʒuEp𒼐ڎwC͂
	+ }EX drag and drop ̂悤ɐ؂ւɂD

	@\ƂẮC
	_Rg[Ȇ̐؂ւ
	_[CJƂ̐ڑ
	V[Ot̂̕Ƃ̐ڑCXV
*/
class FWPointerBase: public UTRefCount{
public:
	FWPointerBase(HIHapticDevice* d):device(d){}
	virtual ~FWPointerBase(){}
	UTRef<HIHapticDevice> device;
	UTRef<SGObject> obj;
	virtual void Step(float dt)=0;					///<	XV
	virtual void Connect(SGScene* scene){}
	virtual void SetScale(float ps, float fs){}
	virtual void SetOutForce(bool f){}
};
///
class FWPointer6D: public FWPointerBase{
protected:
	HIForceDevice6D*& Device(){ return (HIForceDevice6D*&)device; }
	Vec3f pos;
	Quaternionf ori;
	float posScale, forceScale;
	float bOutForce;
	Quaternionf qtOffset;
	Quaternionf qtOffsetInv;
	Vec3f v3Offset;
public:
	FWPointer6D(HIForceDevice6D* d=NULL):FWPointerBase(d){
		posScale=1.0f; forceScale=1.0f;
		bOutForce = false;
	}
	virtual void Init(HIForceDevice6D*);	///<	
	virtual void Connect(SGScene* s);
	virtual void Step(float dt);
	PHSolid* GetSolid(){ return UTRef<PHSolid>(obj); }
	virtual void SetScale(float ps, float fs){posScale=ps; forceScale=fs;}
	virtual void SetOutForce(bool f){ bOutForce = f; }
protected:
	UTRef<PHSolid>& Solid(){ return (UTRef<PHSolid>&)obj; }
};
class FWPointers:public std::vector< UTRef<FWPointerBase> >{
public:
	void Connect(SGScene* s);
	void Step(float dt);
	FWPointerBase* Find(HIHapticDevice* dev);
};

}	//	namespace Spr
#endif
