// HISpidarFinger.cpp: HISpidarFinger NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////


#include "HISpidarHand.h"
#include "HISpidarFinger.h"
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
namespace Spr {

HISpidarFinger::HISpidarFinger()
{

}

HISpidarFinger::~HISpidarFinger()
{

}

void HISpidarFinger::InitInstance(HISpidarHand* pHand,HISpidarMotor* pMotor1,HISpidarMotor* pMotor2 = 0)
{
	this->m_pHand = pHand;
	this->m_pMotor1 = pMotor1;
	BeforeCalib();
}

//Œᒣ͂̐ݒ(0.1N)
void HISpidarFinger::SetMinForce()
{
	m_pMotor1->SetForce(0.1f);
}

//w90xȂăLu[V́AwPOL΂
bool HISpidarFinger::FingerCalib()
{
	FingerEnc1[0]=m_pMotor1->counter->Count();
	return true;
}

//wL΂ăLu[V 
bool HISpidarFinger::FingerCalib1()
{
	FingerEnc1[1]=m_pMotor1->counter->Count();

	//̎ẅʒu
	FingerPos1.X()=m_pHand->GetPos().X()+InitFingerPos1.X();
	FingerPos1.Y()=m_pHand->GetPos().Y()+InitFingerPos1.Y();
	FingerPos1.Z()=m_pHand->GetPos().Z()+InitFingerPos1.Z();

	//1pulse̊px
	RadPerPlus1=(3.141592/2)/(FingerEnc1[0]-FingerEnc1[1]);
	//1pulse̒
	LengthPerPlus1 = 0.05/(FingerEnc1[1]-FingerEnc1[0]);

	return true;
}

void HISpidarFinger::Calc_FingerPos()
{	
	///݂̃GR[_lw̋Ȃpxݒ
	FingerRad1 = m_pMotor1->counter->Count()*RadPerPlus1;
	///݂̃GR[_l玅̒ݒ
	FingerLength1 = m_pMotor1->counter->Count()*LengthPerPlus1;

	///ẅʒu̍XV
	//XW
	FingerPos1.X()=m_pHand->GetPos().X()+InitFingerPos1.X();

	//YW
	FingerPos1.Y()=m_pHand->GetPos().Y()+InitFingerPos1.Y()-50*sin(FingerRad1);

	//ZW
	FingerPos1.Z()=m_pHand->GetPos().Z()+InitFingerPos1.Z()-50*cos(FingerRad1);

 }

void HISpidarFinger::Update()
{
	Calc_FingerPos();
}


}//namespace Spr 